#include "adc.h"
#include "debug.h"

u16 ADC_ConvertedValue[length]={0,0};

//ADCӦGPIOʼԼADCʼ
void adc_Init(void)
{
    GPIO_InitTypeDef GPIO_InitStructure={0};
    ADC_InitTypeDef  ADC_InitStructure={0};

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA |RCC_APB2Periph_ADC1 , ENABLE ); //ʹGPIOAʱӺADC
    RCC_ADCCLKConfig(RCC_PCLK2_Div6); //ADCʱӷƵΪ6Ƶ

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4|GPIO_Pin_5;   //
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN; //GPIOģʽΪģ
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    ADC_InitStructure.ADC_Mode = ADC_Mode_Independent;  //ADCΪģʽ
    ADC_InitStructure.ADC_ScanConvMode = ENABLE;        //ͨģʽ¿ɨģʽ
    ADC_InitStructure.ADC_ContinuousConvMode = ENABLE;  //ÿתģʽ
    ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None; //תⲿ
    ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right; //ADCҶ
    ADC_InitStructure.ADC_NbrOfChannel = length;                //תADCͨĿ
    ADC_Init(ADC1, &ADC_InitStructure);                    //ADC_InitStructureָĲʼADC1Ĵ

    ADC_Cmd(ADC1, ENABLE);      //ʹADC1

    ADC_ResetCalibration(ADC1); //ADC1У׼Ĵ

    while(ADC_GetResetCalibrationStatus(ADC1)); //ȴλУ׼

    ADC_StartCalibration(ADC1); //ADУ׼

    while(ADC_GetCalibrationStatus(ADC1));      //ȴУ׼
}

//ADC DMAģʽ
void DMA_Tx_Init( void )
{
    DMA_InitTypeDef DMA_InitStructure={0};

    RCC_AHBPeriphClockCmd( RCC_AHBPeriph_DMA1, ENABLE ); //ʹܿDMAʱ

    DMA_DeInit(DMA1_Channel1); //λDMA

    DMA_InitStructure.DMA_PeripheralBaseAddr = (u32)&ADC1->RDATAR;  //ַΪADCݼĴַ
    DMA_InitStructure.DMA_MemoryBaseAddr = (u32)ADC_ConvertedValue; //ô洢ַΪȡADCֵַ
    DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralSRC;              //ԴΪ裬DMA䷽ʽΪ赽洢
    DMA_InitStructure.DMA_BufferSize = length;                      //DMAݻС˴Ϊlength
    DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;//DMAģʽر
    DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;         //DMA洢ģʽ
    DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord; //ݴСΪֽ֣
    DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;         //ô洢ݴСΪֽ֣
    DMA_InitStructure.DMA_Mode = DMA_Mode_Circular;     //DMAģʽΪѭģʽ
    DMA_InitStructure.DMA_Priority = DMA_Priority_High; //DMAͨȼΪߣʹһ DMAͨʱȼòӰ
    DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;        //ΪDMA䷽ʽΪ赽洢˽ô洢洢䷽ʽ
    DMA_Init( DMA1_Channel1, &DMA_InitStructure );      //ʼDMA

    DMA_Cmd(DMA1_Channel1 , ENABLE);  //ʹDMA
}

void ADC_DMA_CONF(void)
{
    adc_Init();

    DMA_Tx_Init();

    //  ADC ͨת˳Ϊ1һתʱΪ55.5ʱ
    ADC_RegularChannelConfig(ADC1, ADC_Channel_4, 1, ADC_SampleTime_55Cycles5);
    ADC_RegularChannelConfig(ADC1, ADC_Channel_5, 2, ADC_SampleTime_55Cycles5);

    // ʹADC DMA 
    ADC_DMACmd(ADC1, ENABLE);

    // ûвⲿʹADCת
    ADC_SoftwareStartConvCmd(ADC1, ENABLE);
}
